/* global describe, console, it, require, window, Logdown, chai, sinon */

;(function () {
  'use strict'

  sinon.assert.expose(chai.assert, {prefix: ''})
  var assert = chai.assert

  describe('Logdown()', function () {
    it('should return an existing instance if the prefix is already in use',
       function () {
         var foo = Logdown('foo')
         var foo2 = Logdown('foo')
         assert.equal(foo, foo2)
       })

    it('should give a new prefix color for each instance', function () {
      var foo = Logdown('foo')
      var bar = Logdown('bar')
      var quz = Logdown('quz')
      var baz = Logdown('baz')
      assert.notEqual(foo.opts.prefixColor, bar.opts.prefixColor)
      assert.notEqual(foo.opts.prefixColor, quz.opts.prefixColor)
      assert.notEqual(foo.opts.prefixColor, baz.opts.prefixColor)
    })

    it('should sanitize prefixes name', function () {
      var log1 = Logdown('%cfoo%c')
      assert.equal(log1.opts.prefix, 'foo')

      var log2 = Logdown('%cba%cr')
      assert.equal(log2.opts.prefix, 'bar')
    })

    // For compatibiltiy with debug
    it('should set prefix if string is passed as only argument', function () {
      var log1 = Logdown('foo')
      assert.equal(log1.opts.prefix, 'foo')
    })
  })
}())
